"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Requestly_1 = require("./services/Requestly");
const Mandrill_1 = require("./models/Mandrill");
class MandrillTransport {
    constructor(options) {
        this.options = options;
        this.name = 'MandrillTransport';
        this.version = 'N/A';
    }
    send(mail, done) {
        setImmediate(() => {
            mail.normalize((error, data) => {
                if (error)
                    return done(error);
                let mandrill = new Mandrill_1.Mandrill(this.options.apiKey);
                mandrill.setMessage(data);
                Requestly_1.Requestly.postJSON({
                    protocol: 'https:',
                    hostname: 'mandrillapp.com',
                    path: '/api/1.0/messages/send.json'
                }, mandrill)
                    .then(() => {
                    done(null, {
                        envelope: mail.message.getEnvelope(),
                        messageId: mail.message.messageId(),
                        message: mandrill.message
                    });
                })
                    .catch((e) => done(e));
            });
        });
    }
}
exports.MandrillTransport = MandrillTransport;
